# Task 1

1) See full_adder.vhd and full_adder_solution.txt for comments  
2) See ripple_carry_adder4.vhd  
3) See adder_multiplexer.vhd  
4) See ripple_carry_adder_generic.vhd for the generic adder and testbench.vhd for the testbench.